Attribute VB_Name = "Export_to_MGF_file"
Sub ExportMascotPeakList()

   ' Macro v1 created by M Glueckmannto export peaklists for MASCOT Software out of Data Explorer Software



    Dim precursor As Double
    Dim peaks As Variant
    Dim numPeaks As Long
    Dim fs As Object, a As Object
    
    'Get the precursor mass.  If this is NOT an MS/MS file, it will be <= 0
    ActiveDocument.InstrumentSettings.GetSetting dePreCursorIon, 0, precursor
   
    'Retrieve the peak list
      numPeaks = ActiveDocument.SpecView.GetPeakData2(deSpecPeak2All, deSpecPeakSortMass, 0, 0, peaks)
    Dim Filename As String
    
    'Name the mascot generic peaklist file after the spectrum filename
        nDotPos = 0
        Filename = ActiveDocument.FullName
        nNewDotPos = InStr(1, Filename, ".", vbTextCompare)
        While (nNewDotPos <> 0)
            nDotPos = nNewDotPos
            nNewDotPos = InStr(nDotPos + 1, Filename, ".", vbTextCompare)
        Wend
    
        If (nDotPos = 0) Then
            'coulnd't find an extension
            Filename = Filename & ".txt"
        End If
        
        ' nDotPos now contains the index of the dot that precedes the file
        ' extension.  Remove the extension and add .txt
      Filename = Left(Filename, nDotPos - 1) + ".txt"
  



    
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set a = fs.CreateTextFile(Filename, True)
    'Write out only the monoisotopic peaks
    If precursor > 0 Then
        a.WriteLine ("BEGIN IONS")
        a.WriteLine ("TITLE=" & ActiveDocument.FullName)
        a.WriteLine ("PEPMASS=" & precursor)
        For i = 0 To numPeaks - 1
            If peaks(i, deSpecPeak2IsotopeClusterArea) > 0 Then
                a.WriteLine (peaks(i, deSpecPeak2Mass) & vbTab & peaks(i, deSpecPeak2IsotopeClusterArea))
            End If
        Next i
        a.WriteLine ("END IONS")
    Else
        For i = 0 To numPeaks - 1
            If peaks(i, deSpecPeak2IsotopeClusterArea) > 0 Then
                a.WriteLine (peaks(i, deSpecPeak2Mass) & vbTab & peaks(i, deSpecPeak2IsotopeClusterArea))
            End If
        Next i
    End If
        
    a.Close
End Sub
