VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmMascot 
   Caption         =   "Mascot Toolbox"
   ClientHeight    =   2355
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5865
   OleObjectBlob   =   "frmMascot.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmMascot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Public ieApp As New SHDocVw.InternetExplorer

'Constants
Private Const SECTION_NAME As String = "Mascot"
Private Const APP_NAME As String = "AB Sciex"
Private Const MASCOT_URL As String = "Mascot URL"
'Default Mascot server is Matrix Science WWW site
Private Const strMascotDefaultURL As String = "http://www.matrixscience.com"
'Do not change following filespec
Private Const strMascotEndURL As String = "/cgi/search_form.pl?SEARCH=SQ"
'Title string for messsage boxes
Private Const strMsgBox As String = "Mascot Toolbox"
'Monoisotopic mass of H used when calculating Mr from m/z
Private Const Hydrogen As Double = 1.007825
'Round peak data to this number of decimal places
Private Const Decimals As Integer = 5
'Precursor mass tolerance in ppm
Private Const TOL As Double = 50
'Fragment ion tolerance in Da
Private Const ITOL As Double = 0.25

' Private Profile API
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias _
    "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, _
    ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias _
    "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, ByVal lpString As Any, _
    ByVal lpFileName As String) As Long

Private Sub cmdClose_Click()
    
    ' save URL to registry
    SaveSetting APP_NAME, SECTION_NAME, MASCOT_URL, txtURL.Text
    Me.Hide
    
End Sub

Private Sub cmdProcessing_Click()
    Dim PeakDataSize As Long
    Dim PeakArray() As Double
    Dim ChargeArray() As Double
    Dim intArray() As Double
    Dim i As Long
    Dim j As Long
    Dim Form As Variant
    Dim Element As Variant
    Dim PeakString As String
    Dim Mr As Double
    Dim strTemp As String

    'validate parent mass
    If optMIS.Value Then
        txtParentIon.Text = CStr(Val(txtParentIon.Text))
        If Val(txtParentIon.Text) < 100 Then
            MsgBox "Error: No valid parent ion mass specified", , strMsgBox
            Exit Sub
        End If
    End If
               
    'Get the peak list
    Call GetMSPeaks(PeakArray, ChargeArray, intArray, PeakDataSize)
    
    'Display a search form in MSIE browser
    cmdNavigate_Click
    While ieApp.ReadyState <> READYSTATE_COMPLETE
        DoEvents
    Wend
    
    For Each Form In ieApp.Document.Forms
      'Mascot search form is called mainSearch
      If Form.Name = "mainSearch" Then
          For Each Element In Form.All
            With Element
              'only some elements have names
              If TypeName(Element) = "HTMLTextAreaElement" Or _
                TypeName(Element) = "HTMLInputElement" Or _
                TypeName(Element) = "HTMLSelectElement" Or _
                TypeName(Element) = "HTMLCheckboxElement" Then
                If Element.Name = "QUE" Then
                    'QUE is the query text area
                    'Define the search type and report type
                    If optMIS.Value = True Then
                        PeakString = "SEARCH=MIS" & vbCrLf _
                            & "REPTYPE=Peptide" & vbCrLf _
                            & "BEGIN IONS" & vbCrLf _
                            & "PEPMASS=" & txtParentIon.Text & vbCrLf
                    Else
                        PeakString = "SEARCH=PMF" & vbCrLf _
                            & "REPTYPE=Protein" & vbCrLf
                    End If
                    'paste in the mass intensity pairs
                                                           
                   For i = PeakDataSize - 1 To 0 Step -1
                  
                         If ChargeArray(i) > 1 And optPMF.Value = True Then
                            'need to encode charge
                            Mr = (PeakArray(i) - Hydrogen) * ChargeArray(i)
                            'Only want peptides with Mr > 100
                            If Mr > 100 Then
                                If i >= PeakDataSize - Ionnumber.Value Then
                                    strTemp = Mr & " from(" _
                                    & PeakArray(i) & "," & ChargeArray(i) & "+)" & vbCrLf
                                Else
                                 strTemp = ""
                                End If
                            Else
                                strTemp = ""
                            End If
                        Else
                            'charge 0 is treated as 1, which is also the form default
                            If optMIS.Value = True Then
                                If i >= PeakDataSize - Ionnumber.Value Then
                                    strTemp = PeakArray(i) & " " & intArray(i) & vbCrLf
                                Else
                                    strTemp = ""
                                End If
                            Else
                                'Only want peptides with Mr > 100
                                If PeakArray(i) > 101 Then
                                    If i >= PeakDataSize - Ionnumber.Value Then
                                        strTemp = PeakArray(i) & vbCrLf
                                    Else
                                        strTemp = ""
                                    End If
                                    
                                Else
                                    strTemp = ""
                                End If
                            End If
                        End If
                        PeakString = PeakString & strTemp
                                                             
                                                             
                                                             
                   Next i
                    'only need END IONS for an MIS search
                    If optMIS.Value = True Then
                        PeakString = PeakString & "END IONS" & vbCrLf
                    End If
                    Element.Value = PeakString
                ElseIf Element.Name = "COM" Then
                    'COM is the title
                    Element.Value = ActiveDocument.SpecView.Name
                ElseIf Element.Name = "CHARGE" Then
                    'CHARGE is precursor charge
                    'hardcoded to 1
                    For j = 0 To Element.options.length - 1
                        If Element.options(j).Text = "1+" Then
                            Element.selectedIndex = j
                            Exit For
                        End If
                    Next j
                ElseIf Element.Name = "OVERVIEW" Then
                    'OVERVIEW table display option
                    'hardcoded to clear
                    Element.Checked = 0
                ElseIf Element.Name = "TOL" Then
                    'TOL is precursor mass tolerance
                    Element.Value = TOL
                ElseIf Element.Name = "TOLU" Then
                    'TOLU is precursor mass tolerance units
                    'hardcoded to ppm
                    Element.selectedIndex = 3
                ElseIf Element.Name = "ITOL" Then
                    'ITOL is fragment mass tolerance
                    Element.Value = ITOL
                ElseIf Element.Name = "ITOLU" Then
                    'ITOLU is fragment mass tolerance units
                    'hardcoded to Da
                    Element.selectedIndex = 0
                Else
                    'Add similar ElseIf clauses to over-ride
                    'other form defaults.
                End If
              End If
            End With
          Next Element
      End If
    Next Form
    
    While ieApp.ReadyState <> READYSTATE_COMPLETE
        DoEvents
    Wend
    
End Sub

Private Sub cmdNavigate_Click()
    Dim strURL As String
    Dim pos As Long

    'validate URL
    strURL = Trim(LCase(txtURL.Text))
    
    'could be empty first time through
    If strURL = "" Then
        MsgBox "You have not specified a URL.  The default URL will be used" _
        , , strMsgBox
        strURL = strMascotDefaultURL
    End If
    
    ' strip off trailing junk
    pos = InStr(strURL, "/cgi/")
    If (pos > 0) Then
        strURL = Left(strURL, pos - 1)
    End If
    
    'check for missing http://
    If Left(strURL, 7) <> "http://" Then
        strURL = "http://" & strURL
    End If
    
    'remove trailing /
    If Right(strURL, 1) = "/" Then
        strURL = Left(strURL, Len(strURL) - 1)
    End If

    'may still be wrong, but worth a try
    txtURL.Text = strURL
    
    Set ieApp = New SHDocVw.InternetExplorer
    ieApp.Visible = True
    ieApp.Navigate strURL & strMascotEndURL
    Exit Sub

End Sub

Private Sub optMIS_Click()

    'enable or disable precursor text box according to tye of search
    If optMIS.Value = True Then
        txtParentIon.Enabled = True
        Label1.Enabled = True
    Else
        txtParentIon.Enabled = False
        Label1.Enabled = False
    End If

End Sub

Private Sub optPMF_Click()

    'enable or disable precursor text box according to tye of search
    If optMIS.Value = True Then
        txtParentIon.Enabled = True
        Label1.Enabled = True
    Else
        txtParentIon.Enabled = False
        Label1.Enabled = False
    End If

End Sub




Private Sub UserForm_Initialize()
    Dim strMascotBaseURL As String
    Dim precursor As Double
    'Get the precursor mass.  If this is NOT an MS/MS file, it will be <= 0
    ActiveDocument.InstrumentSettings.GetSetting dePreCursorIon, 0, precursor
      
    precursor = Round(precursor, 4)
    
    'If MSMS spectrum paste the precursor mass into field and select MSMS ion search by default
    If precursor > 0 Then
    
            txtParentIon.Value = precursor
            optMIS.Value = True
            txtParentIon.Enabled = True
            Label1.Enabled = True
    Else
            txtParentIon.Enabled = False
            Label1.Enabled = False
    End If
   
    
    strMascotBaseURL = GetSetting(APP_NAME, SECTION_NAME, _
    MASCOT_URL, strMascotDefaultURL)
    txtURL.Text = strMascotBaseURL
    optMIS_Click
        
End Sub

Sub GetMSPeaks(PeakArray() As Double, ChargeArray() As Double, _
    intArray() As Double, PeakDataSize As Long)
    Dim SpecPeakArray As Variant
    Dim SpecChargeArray As Variant
    Dim SpecIntArray As Variant
    Dim ChargeDataSize As Long
    Dim IntDataSize As Long
    Dim i As Long
                
      PeakDataSize = ActiveDocument.SpecView.GetPeakData(deSpecPeakCentroidMass, _
                                            deSpecPeakSortIntensity, 0, 0, SpecPeakArray)
      
      ChargeDataSize = ActiveDocument.SpecView.GetPeakData(deSpecPeakChargeState, _
                                            deSpecPeakSortIntensity, 0, 0, SpecChargeArray)
      IntDataSize = ActiveDocument.SpecView.GetPeakData(deSpecPeakPeakHeight, _
                                            deSpecPeakSortIntensity, 0, 0, SpecIntArray)
      If PeakDataSize > 0 Then
        ReDim PeakArray(0 To PeakDataSize - 1)
        ReDim ChargeArray(0 To PeakDataSize - 1)
        ReDim intArray(0 To PeakDataSize - 1)
        For i = 0 To PeakDataSize - 1
          PeakArray(i) = Round(SpecPeakArray(i, 0), Decimals)
          If SpecChargeArray(i, 0) = 0 Then
             SpecChargeArray(i, 0) = 1
          End If
          ChargeArray(i) = Round(SpecChargeArray(i, 0), Decimals)
          intArray(i) = Round(SpecIntArray(i, 0), Decimals)
        Next i
      End If
      
End Sub
